diff --git a/include/gpac/internal/m3u8.h b/include/gpac/internal/m3u8.h
index 716f647c45..f18589c870 100644
--- a/include/gpac/internal/m3u8.h
+++ b/include/gpac/internal/m3u8.h
@@ -121,6 +121,6 @@ GF_Err gf_m3u8_parse_sub_playlist(const char *file, MasterPlaylist **playlist, c
 /**
  * Deletes the given MasterPlaylist and all of its sub elements
  */
-GF_Err gf_m3u8_master_playlist_del(MasterPlaylist *playlist);
+GF_Err gf_m3u8_master_playlist_del(MasterPlaylist **playlist);
 
 #endif /* M3U8_PLAYLIST_H */
diff --git a/src/media_tools/m3u8.c b/src/media_tools/m3u8.c
index 73b00e1f88..43fe9191ed 100644
--- a/src/media_tools/m3u8.c
+++ b/src/media_tools/m3u8.c
@@ -633,12 +633,12 @@ MasterPlaylist* master_playlist_new()
 
 /********** master_playlist **********/
 
-GF_Err gf_m3u8_master_playlist_del(MasterPlaylist *playlist) {
-	if (playlist == NULL)
+GF_Err gf_m3u8_master_playlist_del(MasterPlaylist **playlist) {
+	if ((playlist == NULL) || (*playlist == NULL))
 		return GF_OK;
-	assert(playlist->streams);
-	while (gf_list_count(playlist->streams)) {
-		Stream *p = gf_list_get(playlist->streams, 0);
+	assert((*playlist)->streams);
+	while (gf_list_count((*playlist)->streams)) {
+		Stream *p = gf_list_get((*playlist)->streams, 0);
 		assert(p);
 		while (gf_list_count(p->variants)) {
 			PlaylistElement *pl = gf_list_get(p->variants, 0);
@@ -649,11 +649,12 @@ GF_Err gf_m3u8_master_playlist_del(MasterPlaylist *playlist) {
 		gf_list_del(p->variants);
 		p->variants = NULL;
 		stream_del(p);
-		gf_list_rem(playlist->streams, 0);
+		gf_list_rem((*playlist)->streams, 0);
 	}
-	gf_list_del(playlist->streams);
-	playlist->streams = NULL;
-	gf_free(playlist);
+	gf_list_del((*playlist)->streams);
+	(*playlist)->streams = NULL;
+	gf_free(*playlist);
+	*playlist = NULL;
 
 	return GF_OK;
 }
@@ -719,8 +720,7 @@ GF_Err declare_sub_playlist(char *currentLine, const char *baseURL, s_accumulate
 			stream = stream_new(attribs->stream_id);
 			if (stream == NULL) {
 				/* OUT of memory */
-				gf_m3u8_master_playlist_del(*playlist);
-				playlist = NULL;
+				gf_m3u8_master_playlist_del(playlist);
 				return GF_OUT_OF_MEM;
 			}
 			gf_list_add((*playlist)->streams, stream);
@@ -769,8 +769,7 @@ GF_Err declare_sub_playlist(char *currentLine, const char *baseURL, s_accumulate
 				attribs->key_method, attribs->key_url, attribs->key_iv);
 			if (curr_playlist == NULL) {
 				/* OUT of memory */
-				gf_m3u8_master_playlist_del(*playlist);
-				playlist = NULL;
+				gf_m3u8_master_playlist_del(playlist);
 				return GF_OUT_OF_MEM;
 			}
 			assert(fullURL);
@@ -811,8 +810,7 @@ GF_Err declare_sub_playlist(char *currentLine, const char *baseURL, s_accumulate
 					attribs->key_iv);
 				if (curr_playlist == NULL) {
 					/* OUT of memory */
-					gf_m3u8_master_playlist_del(*playlist);
-					playlist = NULL;
+					gf_m3u8_master_playlist_del(playlist);
 					return GF_OUT_OF_MEM;
 				}
 				assert(curr_playlist->element.playlist.elements);
@@ -831,9 +829,8 @@ GF_Err declare_sub_playlist(char *currentLine, const char *baseURL, s_accumulate
 					attribs->key_method, attribs->key_url,
 					attribs->key_iv);
 				if (subElement == NULL) {
-					gf_m3u8_master_playlist_del(*playlist);
+					gf_m3u8_master_playlist_del(playlist);
 					playlist_element_del(curr_playlist);
-					playlist = NULL;
 					return GF_OUT_OF_MEM;
 				}
 				gf_list_add(curr_playlist->element.playlist.elements, subElement);
@@ -859,9 +856,8 @@ GF_Err declare_sub_playlist(char *currentLine, const char *baseURL, s_accumulate
 						curr_playlist->element.playlist.elements = gf_list_new();
 				}
 				if (subElement == NULL) {
-					gf_m3u8_master_playlist_del(*playlist);
+					gf_m3u8_master_playlist_del(playlist);
 					playlist_element_del(curr_playlist);
-					playlist = NULL;
 					return GF_OUT_OF_MEM;
 				}
 				gf_list_add(curr_playlist->element.playlist.elements, subElement);
@@ -987,7 +983,7 @@ GF_Err gf_m3u8_parse_sub_playlist(const char *file, MasterPlaylist **playlist, c
 			/* Playlist MUST start with #EXTM3U */
 			if (len < 7 || (strncmp("#EXTM3U", currentLine, 7) != 0)) {
 				gf_fclose(f);
-				gf_m3u8_master_playlist_del(*playlist);
+				gf_m3u8_master_playlist_del(playlist);
 				GF_LOG(GF_LOG_ERROR, GF_LOG_DASH, ("Failed to parse M3U8 File, it should start with #EXTM3U, but was : %s\n", currentLine));
 				return GF_STREAM_NOT_FOUND;
 			}
diff --git a/src/media_tools/mpd.c b/src/media_tools/mpd.c
index 9f1e3c4627..8089af1ced 100644
--- a/src/media_tools/mpd.c
+++ b/src/media_tools/mpd.c
@@ -1596,9 +1596,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	e = gf_m3u8_parse_master_playlist(m3u8_file, &pl, base_url);
 	if (e) {
 		GF_LOG(GF_LOG_ERROR, GF_LOG_DASH, ("[M3U8] Failed to parse root playlist '%s', error = %s\n", m3u8_file, gf_error_to_string(e)));
-		if (pl)
-			gf_m3u8_master_playlist_del(pl);
-		pl = NULL;
+		gf_m3u8_master_playlist_del(&pl);
 		return e;
 	}
 	if (mpd_file == NULL) {
@@ -1717,7 +1715,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	assert(mpd);
 	e = gf_m3u8_fill_mpd_struct(pl, m3u8_file, base_url, mpd_file, title, update_interval, mimeTypeForM3U8Segments, do_import, use_mpd_templates, is_end,  max_dur, mpd, parse_sub_playlist);
 
-	gf_m3u8_master_playlist_del(pl);
+	gf_m3u8_master_playlist_del(&pl);
 
 	return e;
 }
